<div align='center'>
<h1 align='center'>Aubo Sdk Error Code </h1>
</div>

## 缩写说明
* JNT: joint
* PDL: pedstral
* TP: teach pendant
* COMM: communication
* ENC: encoder
* CURR: current
* POS: position
* PKG: package
* PROG: program
## 错误码
| 错误名称 | 错误码 | 说明 | 建议 |
| :----:| :----: | :----: | :----: |
|DEBUG|0|Debug message {}|suggest...|
|POPUP|1|{}|suggest...|
|JOINT_ERR_OVER_CURRENET|10001|joint{} error: over current|(a) Check for short circuit. (b) Do a Complete rebooting sequence. (c) If this happens more than two times in a row, replace joint|
|JOINT_ERR_OVER_VOLTAGE|10002|joint{} error: over voltage|(a) Do a Complete rebooting sequence. (b) Check 48 V Power supply, current distributer, energy eater and Control Board for issues|
|JOINT_ERR_LOW_VOLTAGE|10003|joint{} error: low voltage|(a) Do a Complete rebooting sequence. (b) Check for short circuit in robot arm. (c) Check 48 V Power supply, current distributer, energy eater and Control Board for issues|
|JOINT_ERR_OVER_TEMP|10004|joint{} error: over temperature|(a) Check robot’s environment and make sure the robot is operating within recommended limits. (b) Do a Complete rebooting sequence|
|JOINT_ERR_HALL|10005|joint{} error: hall|suggest...|
|JOINT_ERR_ENCODER|10006|joint{} error: encoder|Check encoder connections|
|JOINT_ERR_ABS_ENCODER|10007|joint{} error: abs encoder|suggest...|
|JOINT_ERR_Q_CURRENT|10008|joint{} error: detect current|suggest...|
|JOINT_ERR_ENC_POLL|10009|joint{} error: encoder pollustion|suggest...|
|JOINT_ERR_ENC_Z_SIGNAL|10010|joint{} error: enocder z signal|suggest...|
|JOINT_ERR_ENC_CAL|10011|joint{} error: encoder calibrate|suggest...|
|JOINT_ERR_IMU_SENS|10012|joint{} error: IMU sensor|suggest...|
|JOINT_ERR_TEMP_SENS|10013|joint{} error: TEMP sensor|suggest...|
|JOINT_ERR_CAN_BUS|10014|joint{} error: can bus error|suggest...|
|JOINT_ERR_SYS_CUR|10015|joint{} error: system current error|suggest...|
|JOINT_ERR_SYS_POS|10016|joint{} error: system position error|suggest...|
|JOINT_ERR_OVER_SP|10017|joint{} error: over speed|suggest...|
|JOINT_ERR_OVER_ACC|10018|joint{} error: over accelerate|suggest...|
|JOINT_ERR_TRACE|10019|joint{} error: trace accuracy|suggest...|
|JOINT_ERR_TAG_POS_OVER|10020|joint{} error: target position out of range|suggest...|
|JOINT_ERR_TAG_SP_OVER|10021|joint{} error: target speed out of range|suggest...|
|JOINT_ERR_COLLISION|10022|joint{} error: collision|suggest...|
|TOOL_FLASH_VERIFY_FAILED|2010001|Flash write verify failed|suggest...|
|TOOL_PROGRAM_CRC_FAILED|2010002|Program flash checksum failed during bootloading|suggest...|
|TOOL_PROGRAM_CRC_FAILED2|2010003|Program flash checksum failed at runtime|suggest...|
|TOOL_ID_UNDIFINED|2010004|Tool ID is undefined|suggest...|
|TOOL_ILLEGAL_BL_CMD|2010005|Illegal bootloader command|suggest...|
|TOOL_FW_WRONG|2010006|Wrong firmware at the joint|suggest...|
|TOOL_HW_INVALID|2010007|Invalid hardware revision|suggest...|
|TOOL_SHORT_CURCUIT_H|2020001|Short circuit detected on Digital Output: {} high side|suggest...|
|TOOL_SHORT_CURCUIT_L|2020002|Short circuit detected on Digital Output: {} low side|suggest...|
|TOOL_AVERAGE_CURR_HIGH|2020003|10 second Average tool IO Current of {} A is outside of the allowed range.|suggest...|
|TOOL_POWER_PIN_OVER_CURR|2020004|Current of {} A on the POWER pin is outside of the allowed range.|suggest...|
|TOOL_DOUT_PIN_OVER_CURR|2020005|Current of {} A on the Digital Output pins is outside of the allowed range.|suggest...|
|TOOL_GROUND_PIN_OVER_CURR|2020006|Current of {} A on the ground pin is outside of the allowed range.|suggest...|
|TOOL_RX_FRAMING|2030001|RX framing error|suggest...|
|TOOL_RX_PARITY|2030002|RX Parity error|suggest...|
|TOOL_48V_LOW|2040001|48V input is too low|suggest...|
|TOOL_48V_HIGH|2040002|48V input is too high|suggest...|
|PEDSTRAL_PKG_LOST|3010001|Lost package from pedstral|suggest...|
|IFB_ERR_ROBOTTYPE|20001|robot error type! 机械臂类型错误|suggest...|
|IFB_ERR_ADXL_SENS|20002|adxl sensor error! 加速度计芯片错误|suggest...|
|IFB_ERR_EN_LINE|20003|encoder line error! 编码器线数错误|suggest...|
|IFB_ERR_ENTER_HDG_MODE|20004|robot enter hdg mode! 进入拖动示教模式错误|suggest...|
|IFB_ERR_EXIT_HDG_MODE|20005|robot exit hdg mode! 退出拖动示教模式错误|suggest...|
|IFB_ERR_MAC_DATA_BREAK|20006|mac data break! MAC数据中断错误|suggest...|
|IFB_ERR_DRV_FIRMWARE_VERSION|20007|driver firmware version error! 驱动器版本错误（关节固件版本不一致）|suggest...|
|INIT_ERR_EN_DRV|20008|driver enable failed! 机械臂初始化使能驱动器失败|suggest...|
|INIT_ERR_EN_AUTO_BACK|20009|driver enable auto back failed! 机械臂初始化使能自动回应失败|suggest...|
|INIT_ERR_EN_CUR_LOOP|20010|driver enable current loop failed! 机械臂初始化使能电流环失败|suggest...|
|INIT_ERR_SET_TAG_CUR|20011|driver set target current failed! 机械臂初始化设置目标电流失败|suggest...|
|INIT_ERR_RELEASE_BRAKE|20012|driver release brake failed! 机械臂初始化释放刹车失败|suggest...|
|INIT_ERR_EN_POS_LOOP|20013|driver enable postion loop failed! 机械臂初始化使能位置环失败|suggest...|
|INIT_ERR_SET_MAX_ACC|20014|set max accelerate failed! 机械臂初始化设置最大加速度失败|suggest...|
|SAFETY_ERR_PROTECTION_STOP_TIMEOUT|20015|protection stop timeout! 机械臂保护停止超时|suggest...|
|SAFETY_ERR_REDUCED_MODE_TIMEOUT|20016|reduced mode timeout! 机械臂减速模式超时|suggest...|
|SYS_ERR_MCU_COM|20017|robot system error:mcu communication error!|suggest...|
|SYS_ERR_RS485_COM|20018|robot system error:RS485 communication error!|suggest...|
|IFB_ERR_DISCONNECTED|20019|Interface board may be disconnected. Please check connection between IPC and Interface board.|suggest...|
|HW_SCB_SETUP_FAILED|5010001|Setup of Safety Control Board failed|suggest...|
|HW_PKG_CNT_DISAGEE|5010002|Packet counter disagreements|suggest...|
|HW_SCB_DISCONNECT|5010003|Connection to Safety Control Board lost|suggest...|
|HW_SCB_PKG_LOST|5010004|Package lost from Safety Control Board|suggest...|
|HW_SCB_CONN_INIT_FAILED|5010005|Ethernet connection initialization with Safety Control Board failed|suggest...|
|HW_LOST_JOINT_PKG|5010006|Lost package from joint  {}|suggest...|
|HW_LOST_TOOL_PKG|5010007|Lost package from tool|suggest...|
|HW_JOINT_PKG_CNT_DISAGREE|5010008|Packet counter disagreement in packet from joint {}|suggest...|
|HW_TOOL_PKG_CNT_DISAGREE|5010009|Packet counter disagreement in packet from tool|suggest...|
|HW_JOINTS_FAULT|5020001|{} joint entered the Fault State|suggest...|
|HW_JOINTS_VIOLATION|5020002|{} joint entered the Violation State|suggest...|
|HW_TP_FAULT|5020003|Teach Pendant entered the Fault State|suggest...|
|HW_TP_VIOLATION|5020004|Teach Pendant entered the Violation State|suggest...|
|HW_JOINT_MV_TOO_FAR|5030001|{} joint moved too far before robot entered RUNNING State|suggest...|
|HW_JOINT_STOP_NOT_FAST|5030002|Joint Not stopping fast enough|suggest...|
|HW_JOINT_MV_LIMIT|5030003|Joint moved more than allowable limit|suggest...|
|HW_FT_SENSOR_DATA_INVALID|5040001|Force-Torque Sensor data invalid|suggest...|
|HW_NO_FT_SENSOR|5040002|Force-Torque sensor is expected, but it cannot be detected|suggest...|
|HW_FT_SENSOR_NOT_CALIB|5040003|Force-Torque sensor is detected but not calibrated|suggest...|
|HW_RELEASE_BRAKE_FAILED|5050000|Robot was not able to brake release, see log for details|suggest...|
|HW_OVERCURR_SHUTDOWN|5060000|Overcurrent shutdown|suggest...|
|HW_ENERGEY_SURPLUS|5070000|Energy surplus shutdown|suggest...|
|HW_IDLE_POWER_HIGH|5080000|Idle power consumption to high|suggest...|
|ROBOT_BE_PULLING|30001|Something is pulling the robot.|Please check TCP configuration,payload and mounting settings|
|PSTOP_ELBOW_POS|30002|Protective Stop: Elbow position close to safety plane limits.|Please move robot Elbow joint away from the safety plane|
|PSTOP_STOP_TIME|30003|Protective Stop: Exceeding user safety settings for stopping time.|(a) Check speeds and accelerations in the program (b) Check usage of TCP,payload and CoG correctly (c) Check external equipmentactivation if correctly set|
|PSTOP_STOP_DISTANCE|30004|Protective Stop: Exceeding user safety settings for stopping distance.|(a) Check speeds and accelerations in the program (b) Check usage of TCP,payload and CoG correctly (c) Check external equipmentactivation if correctly set|
|PSTOP_CLAMP|30005|Protective Stop: Danger of clamping between the Robot’s lower arm and tool.|(a) Check speeds and accelerations in the program (b) Check usage of TCP,payload and CoG correctly (c) Check external equipmentactivation if correctly set|
|PSTOP_POS_LIMIT|30006|Protective Stop: Position close to joint limits|suggest...|
|PSTOP_ORI_LIMIT|30007|Protective Stop: Tool orientation close to limits|suggest...|
|PSTOP_PLANE_LIMIT|30008|Protective Stop: Position close to safety plane limits|suggest...|
|PSTOP_POS_DEVIATE|30009|Protective Stop: Position deviates from path|Check payload, center of gravity and acceleration settings.|
|JOINT_CHK_PAYLOAD|30010|Joint {}: Check payload, center of gravity and acceleration settings. Log screen may contain additional information.|suggest...|
|PSTOP_SINGULARITY|30011|Protective Stop: Position in singularity.|Please use MoveJ or change the motion|
|PSTOP_CANNOT_MAINTAIN|30012|Protective Stop: Robot cannot maintain its position, check if payload is correct|suggest...|
|PSTOP_WRONG_PAYLOAD|30013|Protective Stop: Wrong payload or mounting detected, or something is pushing the robot when entering Freedrive mode|Verify that the TCP configuration and mounting in the used installation is correct|
|PSTOP_JOINT_COLLISION|30014|Protective Stop: Collision detected by joint|Make sure no objects are in the path of the robot and resume the program|
|PSTOP_POS_DISAGREE|30015|Protective stop: The robot was powered off last time due to a joint position disagreement.| (a) Verify that the robot position in the 3D graphics matches the real robot, to ensure that the encoders function before releasing the brakes. Stand back and monitor the robot performing its first program cycle as expected. (b) If the position is not correct, the robot must be repaired. In this case, click Power Off Robot. (c) If the position is correct, please tick the check box below the 3D graphics and click Robot Position Verified|
|PSTOP_LARGE_MOVE|30016|Protective stop: Large movement of the robot detected while it was powered off. The joints were moved while it was powered off, or the encoders do not function|suggest...|
|TARGET_POS_SUDDEN_CHG|30017|Sudden change in target position|suggest...|
|SUDDEN_STOP|30018|Sudden stop.| To abort a motion, use "stopj" or "stopl" script commands to generate a smooth deceleration before using "wait". Avoid aborting motions between waypoints with blend”|
|ROBOT_STOP_ABNORMAL|30019|Robot has not stopped in the allowed reaction and braking time|suggest...|
|PROG_INVALID_SETP|30020|Robot program resulted in invalid setpoint.|Please review waypoints in the program|
|BLEND_INVALID_SETP|30021|Blending failed and resulted in an invalid setpoint.|Try changing the blend radius or contact technical support|
|APPROACH_SINGULARITY|30022|Robot approaching singularity – Acceleration threshold failed.|Review waypoints in the program, try using MoveJ instead of MoveL in the position close to singularity|
|TSPEED_UNMATCH_POS|30023|Target speed does not match target position|suggest...|
|INCONSIS_TPOS_SPD|30024|Inconsistency between target position and speed|suggest...|
|JOINT_TSPD_UNMATCH_POS|30025|Target joint speed does not match target joint position change – Joint {}|suggest...|
|FIELDBUS_INPUT_DISCONN|30026|Fieldbus input disconnected.|Please check fieldbus connections (RTDE, ModBus, EtherNet/IP and Profinet) or disable the fieldbus in the installation. Check RTDE watchdog feature. Check if a URCap is using this feature.|
|OPMODE_CHANGED|30027|Operational mode changed: {}|suggest...|
|NO_KIN_CALIB|30028|No Kinematic Calibration found (calibration.conf file is either corrupt or missing).|A new kinematics calibration may be needed if the robot needs to improve its kinematics, otherwise, ignore this message)|
|KIN_CALIB_UNMATCH_JOINT|30029|Kinematic Calibration for the robot does not match the joint(s).|If moving a program from a different robot to this one, rekinematic calibrate the second robot to improve kinematics, otherwise ignore this message.|
|KIN_CALIB_UNMATCH_ROBOT|30030|Kinematic Calibration does not match the robot.|Please check if the serial number of the robot arm matches the Control Box|
|JOINT_OFFSET_CHANGED|30031|Large movement of the robot detected while it was powered off. The joints were moved while it was powered off, or the encoders do not function|suggest...|
|OFFSET_CHANGE_HIGH|30032|Change in offset is too high|suggest...|
|JOINT_SPEED_LIMIT|30033|Close to joint speed safety limit.|Review program speed and acceleration|
|TOOL_SPEED_LIMIT|30034|Close to tool speed safety limit.|Review program speed and acceleration|
|MOMENTUM_LIMIT|30035|Close to momentum safety limit.|Review program speed and acceleration|
|ROBOT_MV_STOP|30036|Robot is moving when in Stop Mode|suggest...|
|HAND_PROTECTION|30037|Hand protection: Tool is too close to the lower arm: {} meter.|(a) Check wrist position. (b) Verify mounting (c) Do a Complete rebooting sequence (d) Update software (e) Contact your local AUBO Robots service provider for assistance|
|WRONG_SAFETYMODE|30038|Wrong safety mode: {}|suggest...|
|SAFETYMODE_CHANGED|30039|Safety mode changed: {}|suggest...|
|JOINT_ACC_LIMIT|30040|Close to joint acceleration safety limit|suggest...|
|TOOL_ACC_LIMIT|30041|Close to tool acceleration safety limit|suggest...|
|JOINT_TEMPERATURE_LIMIT|30042|Joint {} temperature too high(>{}℃)|suggest...|
|CONTROL_BOX_TEMPERATURE_LIMIT|30043|Control box temperature too high(>{}℃)|suggest...|
|ROBOT_EMERGENCY_STOP|30044|Robot emergency stop|suggest...|
|ROBOTMODE_CHANGED|30045|Robot mode changed: {}|suggest...|
|ROBOTMODE_ERROR|30046|Robot can not move at {}|suggest...|
|POSE_OUT_OF_REACH|30047|Target pose [{}] out of reach|suggest...|
|TP_PLAN_FAILED|30048|Trajectory plan FAILED.|suggest...|
|START_FORCE_FAILED|30049|Start force control failed, because force sensor does not exist.|suggest...|
|OVER_SAFE_PLANE_LIMIT|30050|{} axis exceeds the safety plane limit (Move_type:{} id:{}).|Please move the robot to the safety plane range.|
|POWERON_FAIL_VIOLATION|30051|Failed to power on because the robot safety mode is in violation|suggest...|
|POWERON_FAIL_SYSTEMEMERGENCYSTOP|30052|Failed to power on because the robot safety mode is in system emergency stop|suggest...|
|POWERON_FAIL_ROBOTEMERGENCYSTOP|30053|Failed to power on because the robot safety mode is in robot emergency stop|Pop up the red emergency stop button on the teach pendant when the robot is in a safe range of motion|
|POWERON_FAIL_FAULT|30054|Failed to power on because the robot safety mode is in fault|suggest...|
|STARTUP_FAIL_VIOLATION|30055|Failed to startup because the robot safety mode is in violation|suggest...|
|STARTUP_FAIL_SYSTEMEMERGENCYSTOP|30056|Failed to startup because the robot safety mode is in system emergency stop|suggest...|
|STARTUP_FAIL_ROBOTEMERGENCYSTOP|30057|Failed to startup because the robot safety mode is in robot emergency stop|Pop up the red emergency stop button on the teach pendant when the robot is in a safe range of motion|
|STARTUP_FAIL_FAULT|30058|Failed to startup because the robot safety mode is in fault|suggest...|
|BACKDRIVE_FAIL_VIOLATION|30059|Failed to backdrive because the robot safety mode is in violation|suggest...|
|BACKDRIVE_FAIL_SYSTEMEMERGENCYSTOP|30060|Failed to backdrive because the robot safety mode is in system emergency stop|suggest...|
|BACKDRIVE_FAIL_ROBOTEMERGENCYSTOP|30061|Failed to backdrive because the robot safety mode is in robot emergency stop|Pop up the red emergency stop button on the teach pendant when the robot is in a safe range of motion|
|BACKDRIVE_FAIL_FAULT|30062|Failed to backdrive because the robot safety mode is in fault|suggest...|
|SETSIM_FAIL_VIOLATION|30063|Switch sim mode failed because the robot safety mode is in violation|suggest...|
|SETSIM_FAIL_SYSTEMEMERGENCYSTOP|30064|Switch sim mode failed because the robot safety mode is in system emergency stop|suggest...|
|SETSIM_FAIL_ROBOTEMERGENCYSTOP|30065|Switch sim mode failed because the robot safety mode is in robot emergency stop|Pop up the red emergency stop button on the teach pendant when the robot is in a safe range of motion|
|SETSIM_FAIL_FAULT|30066|Switch sim mode failed because the robot safety mode is in fault|suggest...|
|FREEDRIVE_FAIL_VIOLATION|30067|Switch freedrive mode failed because the robot safety mode is in violation|suggest...|
|FREEDRIVE_FAIL_SYSTEMEMERGENCYSTOP|30068|Switch freedrive mode failed because the robot safety mode is in system emergency stop|suggest...|
|FREEDRIVE_FAIL_ROBOTEMERGENCYSTOP|30069|Switch freedrive mode failed because the robot safety mode is in robot emergency stop|Pop up the red emergency stop button on the teach pendant when the robot is in a safe range of motion|
|FREEDRIVE_FAIL_FAULT|30070|Switch freedrive mode failed because the robot safety mode is in fault|suggest...|
|UPFIRMWARE_FAIL_VIOLATION|30071|Firmware update failed because the robot safety mode is in violation|suggest...|
|UPFIRMWARE_FAIL_SYSTEMEMERGENCYSTOP|30072|Firmware update failed because the robot safety mode is in system emergency stop|suggest...|
|UPFIRMWARE_FAIL_ROBOTEMERGENCYSTOP|30073|Firmware update failed because the robot safety mode is in robot emergency stop|Pop up the red emergency stop button on the teach pendant when the robot is in a safe range of motion|
|UPFIRMWARE_FAIL_FAULT|30074|Firmware update failed because the robot safety mode is in fault|suggest...|
|SETPERSOSTENT_FAIL_VIOLATION|30075|Set persistent parameter failed because the robot safety mode is in violation|suggest...|
|SETPERSOSTENT_FAIL_SYSTEMEMERGENCYSTOP|30076|Set persistent parameter failed because the robot safety mode is in system emergency stop|suggest...|
|SETPERSOSTENT_FAIL_ROBOTEMERGENCYSTOP|30077|Set persistent parameter failed because the robot safety mode is in robot emergency stop|Pop up the red emergency stop button on the teach pendant when the robot is in a safe range of motion|
|SETPERSOSTENT_FAIL_FAULT|30078|Set persistent parameter failed because the robot safety mode is in fault|suggest...|
|SETPERSOSTENT_FAIL_PARAM_ERR|30079|Set persistent parameter failed|(a) Check the parameter format, whether all are floating point numbers|
|ROBOT_CABLE_DISCONN|30080|Robot cable not connected|(a) Make sure the cable between Control Box and Robot Arm is correctly connected and it has no damage. (b) Check for loose connections (c) Do a Complete rebooting sequence (d) Update software (e) Contact your local AUBO Robots service provider for assistance Contact your local AUBO Robots service provider for assistance.|
|TP_TOO_SHORT|30081|The generated trajectory is ignored because it is too short|(a) Please check if the added waypoints are coincident (b) If it is an arc movement, please check whether the three points are collinear|
|INV_KIN_FAIL|30082|Inverse kinematics solution failed, The target pose may be in a singular position or exceed the joint limits|(a) Change the target pose and try moving again|
|ARCS_MAX_ERROR_CODE|-1|Max error code|suggest...|
