﻿#include <math.h>
#include "aubo_sdk/rpc.h"
#include <math.h>
using namespace arcs::common_interface;
using namespace arcs::aubo_sdk;

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif
std::vector<double> waypoint1;
std::vector<double> waypoint2;
std::vector<double> waypoint3;

//圆弧 (x-0.12294)^2 + (y-0.54855)^2 + (z-0.26319)^2 = 0.2^2
void get_circle_waypoint()
{
    double z1 = 0.26319;
    double y1 = 0.7;
    double x1 = sqrt(pow(0.2, 2) - pow(y1 - 0.54855, 2) - pow(z1 - 0.26319, 2));
    waypoint1 = { x1, y1, z1, 3.14, 0.00, 3.14 };

    double z2 = 0.26319;
    double y2 = 0.55;
    double x2 = sqrt(pow(0.2, 2) - pow(y2 - 0.54855, 2) - pow(z2 - 0.26319, 2));
    waypoint2 = { x2, y2, z2, 3.14, 0.00, 3.14 };

    double z3 = 0.26319;
    double y3 = 0.35;
    double x3 = sqrt(pow(0.2, 2) - pow(y3 - 0.54855, 2) - pow(z3 - 0.26319, 2));
    waypoint3 = { x3, y3, z3, 3.14, 0.00, 3.14 };
}

// 圆弧运动
void exampleMoveC(RpcClientPtr cli)
{
    get_circle_waypoint();
    //关节运动到第一个路点
    auto robot_name = cli->getRobotNames().front();
    cli->getRobotInterface(robot_name)
        ->getMotionControl()
        ->moveLine(waypoint1, 180 * (M_PI / 180), 1000000 * (M_PI / 180), 0, 0);
    std::this_thread::sleep_for(std::chrono::seconds(1));

    //圆弧运动
    int ret = cli->getRobotInterface(robot_name)
                  ->getMotionControl()
                  ->moveCircle(waypoint2, waypoint3, 180 * (M_PI / 180),
                               1000000 * (M_PI / 180), 0, 0);
    if (ret == 0) {
        std::cout << "圆弧运动成功！" << std::endl;
    } else {
        std::cerr << "圆弧运动失败！错误码： " << ret << std::endl;
    }
}

#define LOCAL_IP "127.0.0.1"

int main(int argc, char **argv)
{
    auto cli = std::make_shared<RpcClient>();
    cli->connect(LOCAL_IP, 30004);
    cli->login("aubo", "123456");

    exampleMoveC(cli);

    return 0;
}
