﻿#include "aubo_sdk/rpc.h"

using namespace arcs::common_interface;
using namespace arcs::aubo_sdk;

#define LOCAL_IP "127.0.0.1"
void example_read_log(RpcClientPtr cli)
{
    cli->setLogHandler([](int level, const char *filename, int line,
                          const std::string &message) {
        std::cout << "level: " << level << std::endl;
        std::cout << "filename: " << filename << std::endl;
        std::cout << "line: " << line << std::endl;
        std::cout << "message: " << message << std::endl;
    });
}

int main()
{
    auto rpc_cli = std::make_shared<RpcClient>();
    example_read_log(rpc_cli);
    rpc_cli->connect(LOCAL_IP, 30004);
    rpc_cli->login("aubo", "123456");
    std::cout << "example finish!" << std::endl;
    return 0;
}
